char M_TITLE[] = "Saibara's composite image program for ism Ver.1.00b\n";
char M_HELP[] = "composite_ism.exe <input1 id> <x> <y> <input2 id> <output id>\n";
/*
  ismf[^Ԃŉ摜

  ӓ_F{Iinput1̉摜TCYɑSč킹Binput2,outputTCYłȂ΂ȂȂB
*/
#define DEF_INPUTID	"ism_in"
#define DEF_INPUTID2	"ism_in2"
#define DEF_OUTPUTID	"ism_out"
#define DEF_XSIZE	0
#define DEF_YSIZE	0

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include "s_sharemem.h"
#include "ism_data.h"
#include "s_malloc.h"

#include "checksec.f"

// 摜{̂main_process.cŒ`
// ł͐錾̂
void change_data(unsigned char *buf,int size,int mx,int my,unsigned char *buf2);

// C֐
int main(int argc,char *argv[])
{
  char *inid,*inid2,*outid;
  char *buf,*buf2;
  int x,y,size;
  ism_data *ism_in,*ism_in2,*ism_out;
  ism_head *ismh_in;
  int count,count2;
  ism_time lasttime;

  printf(M_TITLE);
  if(argc == 1)
    {
      printf(M_HELP);
      exit(1);
    }

  inid  = DEF_INPUTID;
  inid2 = DEF_INPUTID2;
  outid = DEF_OUTPUTID;
  x = DEF_XSIZE;
  y = DEF_YSIZE;

  if(argc > 1) { inid  = argv[1]; argc--; argv++; }
  if(argc > 1) { x = atoi(argv[1]); argc--; argv++; }
  if(argc > 1) { y = atoi(argv[1]); argc--; argv++; }
  if(argc > 1) { inid2 = argv[1]; argc--; argv++; }
  if(argc > 1) { outid = argv[1]; argc--; argv++; }

  printf("Processing ism ID '%s' '%s' -> '%s'\n",inid,inid2,outid);
  printf("Image size : %d %d\n",x,y);

  // ismm
  printf("Open Shared memory Input\n");
  ism_in  = ism_alloc_image_shared_memory_rgb(inid,x,y);
  if(ism_in == NULL)
  {
    printf("Can't open share memory\n");
    exit(1);
  }

  // ߂ē͉摜TCYl
  ismh_in = ism_get_head(ism_in);
  x = ism_head_get_width(ismh_in);
  y = ism_head_get_height(ismh_in);
  printf("Image size : %d %d\n",x,y);

  // oismm
  printf("Open Shared memory Output\n");
  ism_out = ism_alloc_image_shared_memory_rgb(outid,x,y);
  if(ism_out == NULL)
  {
    printf("Can't open share memory\n");
    exit(1);
  }

  // obt@m
  size = x * y * 3;
  buf = xalloc(char,size);
  if(buf == NULL)
  {
    printf("Can't allocate buffer memory\n");
    exit(1);
  }
  buf2 = xalloc(char,size);
  if(buf == NULL)
  {
    printf("Can't allocate buffer memory 2\n");
    exit(1);
  }

  count = count2 = 0;
  memset(&lasttime,0,sizeof(ism_time));
  while(1)
    {
      ism_wait_refresh(ism_in,&lasttime);
      ism_copy_data(buf,ism_in);
      if(ism_is_exist_image_shared_memory(inid2))
	{
	  ism_in2  = ism_alloc_image_shared_memory_rgb(inid2,x,y);
	  if(ism_in2 != NULL)
	    {
	      memcpy(buf2,ism_get_data(ism_in2),size);
	      change_data(buf,size,x,y,buf2);
	      ism_free_image_shared_memory(ism_in2);
	      count2++;
	    }
	}
      ism_put_data(ism_out,buf,size);
      ism_update_time_now(ism_out);
      count++;
      if(check_sec())
	{
	  printf("%d/%d image processed.\n",count2,count);
	  count=count2=0;
	}
    }
  ism_free_image_shared_memory(ism_in);
  ism_free_image_shared_memory(ism_out);
}
