#ifndef __IMAGE_DATA_H__
#define __IMAGE_DATA_H__

#include <stdio.h>
#include <stdlib.h>
#include "s_value.h"
#include "s_windows.h"

// 1sNZ̃TCY(3oCgŌŒ肷)
#define SIZE_PIXEL	3

// łpvZ(G[薳)
#define image_num(sx,sy,x,y)((x)+(y)*(sx))

#define out_of_image_range(x,y,xsize,ysize)		\
  (((x)<0)||((x)>=(xsize))||((y)<0)||((y)>=(ysize)))

// :RGB̕тBGRŌŒ肷

unsigned char *get_image_pointer_dir(unsigned char *buf,int xsize,int ysize,
				     int x_pos,int y_pos,int direction);

#define get_image_pointer_nor(buf,sx,sy,x,y)		\
  get_image_pointer_dir(buf,sx,sy,x,y,FALSE)
#define get_image_pointer_rev(buf,sx,sy,x,y)		\
  get_image_pointer_dir(buf,sx,sy,x,y,TRUE)

#ifdef __windows__
#define get_image_pointer_win(buf,sx,sy,x,y)		\
  get_image_pointer_dir(buf,sx,sy,x,y,TRUE)
#else
#define get_image_pointer_win(buf,sx,sy,x,y)		\
  get_image_pointer_dir(buf,sx,sy,x,y,FALSE)
#endif

#define get_red(d)	(*((d)+2))
#define get_green(d)	(*((d)+1))
#define get_blue(d)	(*((d)+0))

unsigned char *get_image_pointer(unsigned char *buf,int xsize,int ysize,
				 int x_pos,int y_pos);
unsigned char *get_image_pointer_null(unsigned char *buf,int xsize,int ysize,
				      int x_pos,int y_pos);

// C[Wf[^̏㉺]
void image_change_upsidedown(unsigned char *src,int mx,int my);
void image_copy_upsidedown(unsigned char *dst,unsigned char *src,
			   int mx,int my);

// C[Wf[^̍E]
void image_change_mirror(unsigned char *src,
			 int mx,int my);
void image_copy_mirror(unsigned char *dst,unsigned char *src,
		       int mx,int my);
#endif
